var mongoose   = require('mongoose'),
    timestamps = require('mongoose-timestamp'),
    Schema     = mongoose.Schema;

var EventSchema = new Schema({
  subject:   { type: String, trim: true, required: true },
  startDate: { type: Date, required: true },
  endDate:   { type: Date, required: true },
  notes:     { type: String },
  email:     { type: Schema.ObjectId, ref: 'Email' },
  valid:     { type: Boolean, default: false },
  user:      { type: Schema.ObjectId, ref: 'User', required: true }
});

EventSchema.plugin(timestamps);

module.exports = mongoose.model('Event', EventSchema);
