var app        = module.exports = require('express')(),
    Err        = require('../../support/error'),
    parseEmail = require('./parse-email'),
    parseEvent = require('./parse-event'),
    Event      = require('../../models/event'),
    Email      = require('../../models/email');

app.head('/', function (req, res) {
  return res.send();
});

app.post('/', function (req, res, next) {
  /* jshint -W106 */
  var emails = req.body.mandrill_events;

  if (!emails || !emails.length) {
    return next(new Err.BadRequest());
  }

  emails.forEach(function (email) {
    var message = email.msg;

    email = new Email({
      raw: message.raw_msg
    });

    parseEmail(email.raw, function (parsedEmail) {
      email.to      = parsedEmail.to;
      email.subject = parsedEmail.subject;
      email.html    = parsedEmail.html;
      email.text    = parsedEmail.text;
      email.from    = parsedEmail.from;

      var event = new Event(parseEvent(parsedEmail));

      email.save(function (err, email) {
        if (err) { return next(err); }
        event.email = email._id;
        event.save(function (err) {
          if (err) { return next(err); }
        });
      });
    });
  });

  return res.send(201);
});
