var _      = require('lodash'),
    chrono = require('chrono-node');

module.exports = function (email) {
  var startDate    = {},
      endDate      = {},
      event        = {},
      autoDuration = false; // Set the duruation to an automatic value

  email.conversation.reverse().forEach(function (message) {
    chrono.parse(message.text, message.date).forEach(function (time) {
      _.extend(startDate, time.start);
      _.extend(endDate, time.end);
    });
  });

  event.subject   = email.subject.replace(/^((re|fwd):\s+)+/i, '');
  event.startDate = new Date(startDate.year, startDate.month, startDate.day, startDate.hour, startDate.minute || 0, startDate.second || 0);
  event.endDate   = (endDate && endDate.year && endDate.month && endDate.day && endDate.hour) || ((autoDuration = true) && new Date(event.startDate));
  event.valid     = startDate.year && startDate.month && startDate.day && startDate.hour;

  autoDuration && event.endDate.setHours(event.endDate.getHours() + 1); // Default to one hour from now

  return event;
};
