var app  = module.exports = require('express')(),
    Event = require('../../models/event');

app.get('/', function (req, res) {
  Event.find(function (err, events) {
    if (err) { return res.send(400, err); }
    return res.json(events);
  });
});

app.get('/:id', function (req, res) {
  var id = req.params.id;

  Event.findById(id, function (err, event) {
    if (err) { return res.send(400, err); }
    return res.send(200, event);
  });
});

app.post('/', function (req, res) {
  var event = new Event(req.body);

  event.save(function (err, event) {
    if (err) { return res.send(400, err); }
    return res.send(201, event);
  });
});

app.delete('/:id', function (req, res) {
  var id = req.params.id;

  Event.findByIdAndRemove(id, function (err, event) {
    if (err) { return res.send(400, err); }
    return res.send(204);
  });
});

app.put('/:id', function (req, res) {
  var id    = req.params.id,
      event = req.body;

  Event.findByIdAndUpdate(id, event, function (err, event) {
    if (err) { return res.send(400, err); }
    return res.send(201, event);
  });
});
