var passport      = require('passport'),
    LocalStrategy = require('passport-local').Strategy,
    User          = require('../models/user');

module.exports = function () {

  passport.serializeUser(function(user, next) {
    next(null, user.id);
  });

  passport.deserializeUser(function (id, next) {
    User.findOne({ _id: id }, function (err, user) {
      next(err, user);
    });
  });

  passport.use(new LocalStrategy({
      usernameField: 'email',
      passwordField: 'password'
    },
    function (email, password, next) {
      User.findOne({ email: email }, function (err, user) {
        if (err) { return next(err); }
        if (!user) {
          return next(null, false, { message: 'Unknown user' });
        }
        user.comparePassword(password, function (match) {
          if (!match) {
            return next(null, false, { message: 'Invalid password' });
          }
          return next(null, user);
        });
      });
    }
  ));
};
