var fs    = require('fs'),
    cases = require('change-case'),
    parse = require('../lib/routes/emails/parse-email');

var hasConversation = function (conversation, expectedConversation) {
  var messages = expectedConversation.every(function (expected) {
    return conversation.some(function (message) {
      return message.text.trim() === expected.text.trim() &&
          message.date.getTime() === expected.date.getTime();
    });
  });

  return messages ? null : new Error('Conversation not found');
};

describe('Parsing emails', function () {
  fs.readdirSync(__dirname + '/fixtures/emails').forEach(function (file) {
    if (!/\.txt$/i.test(file)) { return; }

    var filename = file.replace(/\.txt$/, ''); // Replace the trailing

    it(cases.titleCase(filename), function (next) {
      parse(fs.readFileSync(__dirname + '/fixtures/emails/' + file), function (email) {
        next(hasConversation(email.conversation, require('./fixtures/emails/' + filename)));
      });
    });
  });
});
