var test = require('./support/http');

describe('/events', function () {
  var id,
      event = {
        subject: 'DO YOU EVEN LIFT',
        startDate: Date.now(),
        endDate: Date.now(),
        notes: '',
        email: '519af8d7a0d5ef8211000005',
        user: '519af8d7a0d5ef8211000005'
      };

  it('should respond to GET', function (done) {
    test('get', '/events').expect(200, done);
  });

  it('should respond to POST but fail due to no params', function (done) {
    test('post', '/events').expect(400, done);
  });

  it('should respond to POST and respond with success code', function (done) {
    test('post', '/events')
      .send(event)
      .expect(201)
      .end(function (err, res) {
        if (err) { return done(err); }

        id = res.body._id;

        return done();
      });
  });

  it('should DELETE the event that was created', function (done) {
    test('del', '/events/' + id).expect(204, done);
  });

  it('should not DELETE a non existent event', function (done) {
    test('del', '/events/' + '123456789').expect(400, done);
  });

});
