var cr     = require('complexity-report'),
    path   = require('path'),
    glob   = require('glob'),
    modTab = require('tab'),
    list   = [];

glob.sync(__dirname + '/../lib/**/*.js').forEach(function (file) {
  var relativeFile = path.relative(path.dirname(__dirname) + '/lib', file);

  cr.run(require('fs').readFileSync(file, 'utf-8'), {
    newmi: true
  }).functions.forEach(function (entry) {
    list.push([ entry.complexity.cyclomatic, entry.name, relativeFile, entry.line ]);
  });
});


list.sort(function (x, y) {
  return y[0] - x[0]; // Sort by cyclomatic complexity descending
});

modTab.emitTable({
    columns: [{
        label: 'INDEX',
        width: 6
    }, {
        label: 'FUNCTION',
        width: 40
    }, {
        label: 'FILE',
        width: 40
    }, {
        label: 'LINE',
        width: 5
    }],
    rows: list.slice(0, 10)
});
